import _ from 'lodash';

//异步返回值验证是否存在 并返回有用的部分 为啥叫这个名字 写这个函数的时候在听小说
export const monk = (param: any, key = 'items', def = []) => {
  if (param) {
    if (param[key]) {
      return param[key];
    } else {
      return param;
    }
  } else {
    return def;
  }
}

//轮询？ 为什么不用ws 后端不给支持啊 卧槽！！！
export const plObj: any = {};
export const polling = (url: '', options: any = {
  key: '', startUrl: '', timer: 3000, callback: () => {
  }
}, environment) => {
  const poll = option => {
    if (url === option.startUrl) {
      option.callback();
      plObj[option.key] = setInterval(() => {
        option.callback();
      }, !environment.polling ? 300000000000000 : option.timer ? option.timer : 3000);
    } else {
      try {
        clearInterval(plObj[option.key]);
      } catch (e) {
      }
    }
  }

  if (_.isArray(options)) {
    options.forEach(option => {
      poll(option)
    })
  } else {
    poll(options)
  }
}

//对比 为啥写这个 让某个equal折腾的变sb了有木有 有木有！！！
//keys中变了任意一个 就返回true
export const noCompare = '__dont compare';
export const euqal = (now, next, keys: string[] | string) => {
  let bl = false;

  switch (typeof keys) {
    case 'object':
      (<string[]>keys).forEach(key => {
        if (!_.isEqual(now[key], next[key]) && next[key] !== noCompare) {
          bl = true;
        }
      })
      break;
    case 'string':
      if (!_.isEqual(now[(<string>keys)], next[(<string>keys)]) && next[(<string>keys)] !== noCompare) {
        bl = true;
      }
      break;
    default:
  }

  return bl;
}

//为啥写这个 卧槽 完全不像跟后台bb 有bb的功夫不如写个函数 估计我离开这公司后面的人得卷死后端程序
export const toggle = (type, data) => {
  const actions = [];

  if(data){
    if(data.responseCommand.toLowerCase() === 'ok'){
      actions.push({
        type,
        payload: true,
      })
    }else {
      actions.push({
        type,
        payload: false,
      })
    }

    actions.push({
      type,
      payload: noCompare,
    })
  }

  return actions;
}

interface TipParams {
  state: any;
  nextState: any;
  key: string;
  success: () => void;
  error?: () => void;
  common?: () => void;
}
export const tipCallback = ({state, nextState, key, success, error, common}: TipParams) => {
  if (euqal(state, nextState, key)) {
    if (nextState[key] === true) {
      success();
    }

    if (nextState[key] === false) {
      error();
    }

    common();
  }
}

export const fileExport = payload => {
  return payload.responseCommand.toLowerCase() === 'ok' ? '/file/' + payload.requestCommand : false;
}
